/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 7/20/2006; 8:10:10 PM

#include "All.h"

/*

*/
char drawMapInfo(unsigned char mapNumber) {
	unsigned char *dest = LCD_MEM+4+14*30;
	unsigned char *mapPtr = (unsigned char*)&m[mapNumber];
	short xx;
	short yy;
	
	if (TI89) {
		dest = LCD_MEM;
	}
	#define x	15
	#define y	20
	ClrScr();
	
	FastOutlineRect(dest,x,y,x+65,y+65,A_NORMAL);
	FastOutlineRect(dest,x-1,y-1,x+66,y+66,A_NORMAL);
	unsigned char *dest2 = dest+2+21*30;
	for (xx=64;xx--;) {
		for (yy=64;yy--;mapPtr++) {
			 if (*mapPtr!=98)
			 EXT_SETPIX(dest2,xx,yy);
		}
	}
	PortSet (dest, 239, 127);
	FontSetSys(0);
	DrawStr(88,20,m[mapNumber].name,A_NORMAL);
	FastDrawLine(dest,88,27,88+DrawStrWidth(m[mapNumber].name,0),27,A_NORMAL);
	char s[100];
	if (allocatedMem->saveFile!=NULL) {
		Scores *scores = &(allocatedMem->saveFile->scores[mapNumber]);
		sprintf(s,"Best lap: %i",scores->bestLap);
		DrawStr(90,40,s,A_NORMAL);
		sprintf(s,"Best 3 laps: %i",scores->best3Laps);
		DrawStr(90,50,s,A_NORMAL);
		sprintf(s,"Attemps: %i",scores->attemps);
		DrawStr(90,60,s,A_NORMAL);	
		sprintf(s,"laps made: %i",scores->laps);
		DrawStr(90,70,s,A_NORMAL);	
	}
	else
	{
		DrawStr(90,40,"No info available",A_NORMAL);
	} 
	const char *ss[] = {"hide ghost \x12    ", "\x11 show Ghost      "};
	if (allocatedMem->saveFile && allocatedMem->p.raceMode==THREE_LAPS) {
		if (allocatedMem->saveFile->ghostSave[mapNumber].hasContent) {
			DrawStr(90,80,ss[allocatedMem->saveFile->wantToShowGhost],A_REPLACE);
		}
	}
	#undef x
	#undef y

	while(1) {
		if (_keytest(RR_ESC)) {
			PortRestore();
			return FALSE;
		}
		if (_keytest(RR_ENTER) || _keytest(RR_2ND)) {
			PortRestore();
			return TRUE;
		}
		if (allocatedMem->saveFile && allocatedMem->p.raceMode==THREE_LAPS) {
			if (allocatedMem->saveFile->ghostSave[mapNumber].hasContent) {
				if (_keytest(RR_LEFT) || _keytest(RR_RIGHT)) {
					if (_keytest(RR_LEFT))
					allocatedMem->saveFile->wantToShowGhost = FALSE;
					if (_keytest(RR_RIGHT))
					allocatedMem->saveFile->wantToShowGhost = TRUE;			
					DrawStr(90,80,ss[allocatedMem->saveFile->wantToShowGhost],A_REPLACE);
				} 
			}
		}	
	}
}