/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 2/25/2006; 11:45:45 AM

#include "All.h"


short simplifyAngle(short );

/*
	Creates a list that contains the pixel number of the source for every destination
*/
void createTable(unsigned short *t, short a) {
	memset((char *)t,0,16*16*sizeof(short));
	short destX, destY;
	long srcX, srcY, srcX2, srcY2;
	short COS,SIN;
	COS=cosTable_512[a];
	SIN=-sinTable_512[a];	
	srcX= ((15*(-COS-SIN))>>1)+(15<<8);//+(15<<8);
	srcY= ((15*(-SIN+COS))>>1)+(15<<8);//+(15<<8);	
	for (destY=16;destY--;) {		
		srcX2 = srcX;
		srcY2 = srcY;
		for (destX=16;destX--;) {
			if (srcX2>1 && srcX2<(14<<9) && srcY2>1 && srcY2<(14<<9)) {
				*t = (srcX2>>9) + (15<<4)-((srcY2>>5)&0xFFF0);
			}
			else
			{
				*t = 0;
			}
			t++;
			srcX2+=COS;
			srcY2+=SIN;
		}
		srcX+=SIN;
		srcY-=COS;
	}
}