/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 1/19/2006; 11:01:04 PM

#include "All.h"


//Sprite Rotation.c
void createTable(unsigned short *t, short);


/*
	Rotates the tiles and displays them
*/
void displayMap(unsigned char l[][128], short x, short y, short angle, char *buffer) {
	memset(buffer,0,LCD_SIZE);
	if (_keytest(RR_F5))
	angle=0;
	unsigned short table[16*16];
	createTable(table, angle);
	unsigned short rotatedTiles[NUMBER_OF_TILES*16];
	unsigned char tileIsRotated[NUMBER_OF_TILES];
	memset(tileIsRotated,FALSE,NUMBER_OF_TILES);
	#define B		12
	//(TI89?9:12)
	x+=2;
	y+=14;
	short COS=cosTable_128x12[angle];
	short SIN=sinTable_128x12[angle];
	short COS2=cosTable_512[angle]>>2;
	short SIN2=sinTable_512[angle]>>2;	
	short dx = -((x%12)),dy = (y%12);
	short xStart=	(((240-12)/2)<<7) -(3<<6)	+	B*((-COS-SIN)) + (dx*COS2) + (dy*SIN2);// 
	short yStart=	(((128-12)/2)<<7) -(3<<6) + B*((-SIN+COS)) + (dx*SIN2) - (dy*COS2);//
	short i,j;
	short XX,YY;
	l = (void*) (&l[(y/12)-B][(x/12)-B]);
	for (i=0; i<2*B; i++) {//x
		XX = xStart;
		YY = yStart;
		for (j=B*2; j--;) {//y
			unsigned short tileIndex = l[j][i];
			unsigned short tileDestIndex = tileIndex<<4;
			unsigned short tileSrcIndex = tileDestIndex<<4;
				if (tileIndex!=WHITE_TILE) {
					if (!tileIsRotated[tileIndex]) {							
						tileIsRotated[tileIndex] = TRUE;
						unsigned short *xySrc = table;
						unsigned short *dest = &rotatedTiles[tileDestIndex];
						unsigned short *src = &allocatedMem->decompressedTiles->data[tileSrcIndex];
						memset(dest,0,16*2);
						short yDest;  
						for (yDest=16;yDest--;) {
							#define PIX(n) vDest |= (src[*xySrc++]) & (1<<(n))
							#define PIX4(n) PIX(n),PIX(n+1),PIX(n+2),PIX(n+3) 
							#define PIX16(n) PIX4(n),PIX4(n+4),PIX4(n+8),PIX4(n+12) 
							unsigned short vDest = 0; 
							PIX16(0); 
							*dest++ = vDest;  
							#undef PIX 
							#undef PIX4 
							#undef PIX16
						}
					}
					ClipSprite16_OR_R(XX>>7,YY>>7,16,&rotatedTiles[tileDestIndex],buffer);
				}
			XX += SIN;
			YY -= COS;
		}
		xStart += COS;
		yStart += SIN;
	}
}